package de.scrum_master.aspect;

public interface InstrumentedRunnableCallable {
  public static aspect Implementation {
    declare precedence : Implementation, *;

    private long InstrumentedRunnableCallable._id = -1;

    // Java could reuse thread ID. Ignored for now since we target thread pool
    // that use long-live threads.

    // Records which thread created this Object.
    private long InstrumentedRunnableCallable._creator_tid = -1;

    public long InstrumentedRunnableCallable.getId() {
      return _id;
    }

    public void InstrumentedRunnableCallable.setId(long id) {
      _id = id;
    }

    public long InstrumentedRunnableCallable.getCreatorTid() {
      return _creator_tid;
    }

    public void InstrumentedRunnableCallable.setCreatorTid(long id) {
      _creator_tid = id;
    }

    public String InstrumentedRunnableCallable.toStringIRC() {
      return getClass().getName() + "(instanceID=" + _id + ", creatorTID=" + _creator_tid + ")";
    }

    declare parents: (Runnable)+ implements InstrumentedRunnableCallable;
    declare parents: (Callable)+ implements InstrumentedRunnableCallable;
  }
}
